下载之家:专注下载8年,极速安全,用心打造!

下载之家首页 |最新软件 |软件排行 |软件专题

您当前所在位置: 下载之家 >  教程 >  PC软件教程 >  办公软件 >  如何将Excel测量数据导入CAD中并绘图

如何将Excel测量数据导入CAD中并绘图

时间:2016/11/02 14:27:40来源:下载之家作者:Mr.Dai

导读:CAD被广泛应用于建筑,机械,电子等领域,用户量很大,现在很多学校都有开设CAD课程。本文要讲的是如何将Excel测量数据导入CAD中并绘图,有需要的朋友可以看看。

  CAD被广泛应用于建筑,机械,电子等领域,用户量很大,现在很多学校都有开设CAD课程。本文要讲的是如何将Excel测量数据导入CAD中并绘图,有需要的朋友可以看看。

  这是用CAD的VBA(cad里的lisp功能也可以实现)的方法。此例是要完成如何在CAD中画出如下图所示的坐标的图形——3D折线(另画一圆弧)。当然如果学会了此种绘图的办法之后,还可以照葫芦画瓢地进行更高级的绘图了。

  一、新建excel工作簿,命名为"EAHT",保存于D:\cadvba文件夹内 (无此文件夹可新建,若存于别处则需相应修改一下代码中路径代码) ,将一工作表命名为"EAT",并在其相应位置填入数据(文字备注可不填),保存备用。

如何将Excel测量数据导入CAD中并绘图

  二、用宏画图

  1. 打开CAD,单击CAD界面工具菜单→宏→Visual Basic编辑器,打开VBA编辑器。(快捷键alt+F1,若一次不行就再按一次)。

  2.单击Visual Basic界面插入→模块,主页面会打开模块代码窗口,向其输入如下代码(画折线的):

  Dim xlapp As Excel.Application

  Dim xlbook As Excel.workbook

  Dim xlsheet As Excel.worksheet

  Sub zx() '宏名-折线(轴测图或动态观察可见3D效果)

  Set xlapp = CreateObject("excel.application")

  Set xlbook = xlapp.workbooks.Open("D:\cadvba\eaht.xlsx") '打开EXCEL的路径及名称,早期

  ‘excel的扩展名是xls。

  xlapp.Visible = False’ 隐藏工作簿

  Set xlsheet = xlbook.worksheets("eat") '选用EXCEL中名为“eat”的工作表中的数据

  i = xlsheet.Cells(1, 6) 'i为线条线数

  m = xlsheet.Cells(2, 6) '这里表示第2行第6列那个单元格里的数值

  n = xlsheet.Cells(3, 6)

  T = xlsheet.Cells(4, 6)

  For p = 0 To i - 2 Step 1

  k1 = xlsheet.Cells(2 + p, 1)

  h1 = xlsheet.Cells(2 + p, 2)

  k3 = xlsheet.Cells(2 + p, 3)

  k2 = xlsheet.Cells(3 + p, 1)

  h2 = xlsheet.Cells(3 + p, 2)

  h3 = xlsheet.Cells(3 + p, 3)

  Dim 直线 As AcadLine

  Dim 起点(2) As Double

  Dim 端点(2) As Double

  起点(0) = k1 + m

  起点(1) = h1 + n

  起点(2) = k3 + T

  端点(0) = k2 + m

  端点(1) = h2 + n

  端点(2) = h3 + T

  Set 直线 = ThisDrawing.ModelSpace.AddLine(起点, 端点)

  Next

  ZoomExtents '缩放至满幅

  xlbook.Close

  xlapp.Quit

  Set xlapp = Nothing

  End Sub

  3.打开vba编辑器的工具→引用,从引用对话窗找到Microsoft Excel xx.x Object Library,点击其左边的□,出现勾符号(如果没有此项,可浏览打开EXCEL.exe文件即可,文件位置一般此是C:\Program Files\Microsoft Office\Officexx,其扩展名可能未显示),然后确定。

  4.做好这几步之后就保存编辑内容,然后点击工具栏上的▲(向右)或按F5或点击工具菜单→运行就可以画出折线了,到cad界面可见。或返回CAD后按快捷键Alt+F8(一次不行就再按一次)启动宏,然后选中名字为zx的那个宏(工程中只有一个宏是默认选中),点击运行按钮,此时CAD界面上就会自动将图画出来(轴测图或动态观察可见3D效果)。

  三、用窗体画图

  1. 打开CAD,单击CAD界面工具菜单→宏→Visual Basic编辑器,打开VBA编辑器。(快捷键alt+F1,若一次不行就再按一次)。

  2.单击Visual Basic界面插入→用户窗体,主页面会出现窗体窗口,加入控件,标签不是必须,控件属性可以默认。双击窗体打开窗体代码窗口,向其输入如下代码(画圆弧):

  Private Sub CommandButton1_Click() '

  Dim curves(0 To 1) As AcadEntity

  Dim centerpoint(0 To 2) As Double

  Dim radius As Double

  Dim startangle As Double

  Dim endangle As Double

  'Debug.Print OptionButton1 _

  Debug.Print OptionButton2

  If TextBox1 = "" Then

  Set xlapp = CreateObject("excel.application")

  Set xlbook = xlapp.workbooks.Open("D:\cadvba\eaht.xlsx") '打开的EXCEL路径

  xlapp.Visible = False

  Set xlsheet = xlbook.worksheets("eat") '打开EXCEL中名为“eat”的工作表

  centerpoint(0) = xlsheet.Cells(14, 1) '(圆心X坐标):

  centerpoint(1) = xlsheet.Cells(14, 2) ' (圆心Y坐标):

  centerpoint(2) = xlsheet.Cells(14, 3) ' (圆心Z坐标) '{圆心坐标}

  radius = xlsheet.Cells(14, 4) '(所画弧处圆的半径) '{半径}

  startangle = xlsheet.Cells(14, 5) ' (所画弧起点弧度值) '角度/180*3.141592653

  endangle = xlsheet.Cells(14, 6) ' (所画弧终点弧度值)

  Else

  centerpoint(0) = TextBox1

  centerpoint(1) = TextBox2

  centerpoint(2) = TextBox3

  radius = TextBox4

  If OptionButton1 = True And OptionButton2 = False Then

  startangle = TextBox5 / 180 * 3.1416

  endangle = TextBox6 / 180 * 3.1416

  ElseIf OptionButton1 = False And OptionButton2 = True Then

  startangle = TextBox5

  endangle = TextBox6

  Else

  MsgBox "角度单位不明确"

  End If

  End If

  Set curves(0) = ThisDrawing.ModelSpace.AddArc(centerpoint, radius, startangle, endangle)

  ZoomExtents

  End Sub

  3. 做好这几步之后就保存编辑内容,然后点击工具栏上的▲(向右)或按F5或点击工具菜单→运行就会出现用户窗体,若用excel中数据画弧就点击命令按钮-画弧,若用窗体改变参数就向窗体填数并选择角度单位,然后点击画弧按钮,然后,到cad界面可见既定圆弧线。

  注意:

  1.如果画弧程序不是与折线程序做在同一工程中,则全局变量要在模块中另行定义,并引用Microsoft Excel xx.x Object Library。

  2.CAD2010以后不带VBA,需要另行安装。

更多0

相关阅读 Excel2010删除图片背景的方法 福昕pdf如何删除其中一页? Office2007永久密钥序列号真实管用 福昕阅读器PDF语音朗读功能怎么用? office2007最新密钥大全 office2007密钥最新参考 ppt演示设置边讲边画的图文方法 福昕阅读器注释怎么用?福昕阅读器注释使用技巧 PPT制作图片十字绣效果的方法